﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace sample
{
    class Sample
    {
        static void Main(string[] args)
        {
          var numbers = new List<int> {1, 2, 3, 5, 4, 6, 7, 8, 9, 10};
          
          Console.WriteLine(
            numbers.Where(IsGreaterThan3)
                   .Where(IsEven)
                   .Select(DoubleIt)
                   .First()
            );
        }
        
        static bool IsGreaterThan3(int number) {
          Console.WriteLine("IsGreaterThan3 called for {0}", number);
          return number > 3;
        }

        static bool IsEven(int number) {
          Console.WriteLine("IsEven called for {0}", number);
          return number % 2 == 0;
        }

        static int DoubleIt(int number) {
          Console.WriteLine("DoubleIt called for {0}", number);
          return number * 2;
        }
    }
}
