using System;

namespace sample {
  public class PropertyComputer {
    Func<double, double> algorithm;

    public PropertyComputer(Func<double, double> theAlgorithm) {
      algorithm = theAlgorithm;
    }

    public double compute(double input) {
      Console.WriteLine("computing...");
      double result = algorithm(input);
      Console.WriteLine("calibrating the result...");
      return result;
    }
  }
}